import java.awt.Color;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.lekan.graphics.*;


	public class Node{
		String name;
		int xCord;
		int yCord;
		boolean destination;
		List<Edge> edges;
		Node previous;
		int listLoc;
		
	public Node(String name, int x, int y, boolean dest, int l) {
		edges = new ArrayList<Edge>();
		this.name = name;
		xCord = x;
		yCord = y;
		destination = dest;
		previous = null;
		listLoc = l;
	}
	public void setLoc(int n)
	{
		listLoc = n;
	}
	public int getLoc()
	{
		return listLoc;
	}
	public boolean isDest()
	{
	 return destination;
	}
	public String getName()
	{
		return name;
	}
	public int getXcord()
	{
		return this.xCord;
	}
	public int getYcord()
	{
		return this.yCord;
	}
	public Color returnColor()
	{
		if(destination)
		{
			return Color.blue;
		}
		else
		{
			return Color.green;
		}
	}
	public List<Edge> getEdges()
	{
		return edges;
	}
	
	public void changeName(String s)
	{
		this.name = s;
	}
	public void addEdge(Edge e)
	{
	edges.add(e);
	}
	public void setLast(Node n)
	{
		previous = n;
	}
	public Node getLast()
	{
		return previous;
	}
	public Node getPrevious()
	{
		return previous;
	}
	public SGObject getShape()
	{		
		if(destination)
		{
			SGRect square = new SGRect(xCord, yCord, 10, 10);
			return square;
		}
			else
			{
				SGRect square = new SGRect(xCord, yCord, 5, 5);
				return square;
			}
		
	}
}


