import java.awt.Color;
import org.lekan.*;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.io.BufferedWriter;
import java.io.FileWriter;

import javax.swing.JTextField;

import org.lekan.graphics.*;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;
import java.util.Set;

/**
 * Who needs Google Maps when you have Pathfinder?
 * 
 * @author [Hunter McNichols]
 *
 */
public class Pathfinder extends GraphicsProgram {
	public static void main(String[] args) {
		new Pathfinder();
	}
	
	// Constants
	private static final int CANVAS_WIDTH = 1000;
	private static final int CANVAS_HEIGHT = 618;
	private static final String editName = "Edit";
	private static final String wayName = "Waypoint";
	private static final String destName = "Desination";
	private static final String SAVEBUTTEXT = "Save";
	private static final String LOADBUTTEXT = "Load";
	private static final String mapFile =  "USAmap-1000x618.png";
	private static final String SAVEFILE = "save.txt";
	private static final String SEARCHMODE = "Search Mode";
	private static final String SEARCH1= "Search A";
	private static final String COSTTEXT = "Cost Override";
	private static final String CLEARTEXT = "Reset";
	private boolean edit, way, dest, addingEdge, searchMode;
	private int wayIndex = 0;
	private int listIndex =0;
	private Node startNode, endNode;
	private Graph points;
	private List<SGText> texts;
	private List<Edge> edges;
	private JTextField destBox;
	private JTextField costBox;
	private JTextField startDest;
	private JTextField endDest;
	private Node startN,endN;

	
	// [YOUR DATA STRUCTURES WILL GO HERE]
	
		public void setup() {
		// Setup code goes here
		destBox = new JTextField("Please enter destination name", 30);
		costBox = new JTextField(COSTTEXT,10);
		startDest = new JTextField(5);
		endDest = new JTextField(5);
		points = new Graph();
		texts = new ArrayList<SGText>();
		edges = new ArrayList<Edge>();
		this.getFrame().setTitle("Pathfinder BETA!");
		this.getFrame().setDimensions(CANVAS_WIDTH, CANVAS_HEIGHT);
		this.addButton(editName, NORTH);
		this.addButton(wayName, NORTH);
		this.addButton(destName, NORTH);
		this.addButton(SAVEBUTTEXT, SOUTH);
		this.addButton(LOADBUTTEXT, SOUTH);
		this.addButton(CLEARTEXT, SOUTH);
		this.addButton(SEARCHMODE, NORTH);
		this.addTextField(destBox, EAST);
		this.addTextField(costBox, EAST);
	}

	public void actionPerformed(ActionEvent e)
	{
		String current = e.getActionCommand();
		this.drawObjects();
		if(current.equals(editName))
	     {
			SGText t = new SGText("EDIT MODE", 50, 50);
			if(!edit)
			{
			texts.add(0, t);
			edit = true;
			}
			else
			{
				edit = false;
				texts.remove(0);
			}	
			drawObjects();
		}
		if(current.equals(wayName))
		{
			if(way)
				way = false;
			else
			{
			way = true;
			dest = false;
			}
		}
		if(current.equals(destName))
		{
			if(dest)
				dest = false;
			else
			{
				way = false;
				dest = true;	
			}
		}
		if(current.equals(SAVEBUTTEXT))
		{
			this.save();
		}
		if(current.equals(LOADBUTTEXT))
		{
			this.load();
		}
		if(current.equals(SEARCHMODE))
		{
		this.addButton(SEARCH1, WEST);
		this.addTextField(startDest, WEST);
		this.addTextField(endDest, WEST);
		}
		if(current.equals(SEARCH1))
				{
				convertPath(startDest.getText(), endDest.getText());
				ArrayList<Node> result = mySearch(startN, endN);
				highlightPath(result);
				//System.out.println(result);
				//ArrayList<Node> nodies = myNodeSearch(startN, endN);
				printNodes(result);
			
				
				}
		if(current.equals(CLEARTEXT))
		{
			clearAll();
		}
	}
	public void flipArray(ArrayList<Node> a)
	{
		ArrayList<Node> temp = a;
		a.clear();
		for(int k=0; k<temp.size(); k++)
		{
			a.add(temp.get(k));
		}
	}
	public void printNodes(ArrayList<Node> arr)
	{
		String result = "[";
		for(int k=0; k<arr.size(); k++)
		{
			if(k==arr.size()-1)
			{
			result = result + arr.get(k).getName();	
			}
			else
			{
			result = result + arr.get(k).getName()+"-> ";
			}
		}
		result = result + "]";
		System.out.println(result);
	}
	 public void save()
	 
	{
	try {
		BufferedWriter writer = new BufferedWriter(new FileWriter(SAVEFILE));
		
		writer.write(mapFile);
		writer.write("\n");
		writer.write("POINTS\n");
		for(int a=0; a< points.size(); a++)
		{
			if(points.get(a).isDest()==true)
			{
			writer.write("POINT"+"\t"+points.get(a).getName() + "\t" + points.get(a).getXcord() + "\t"
					+ points.get(a).getYcord()+"\tdest"+"\t"+points.get(a).getLoc());
			writer.write("\n");
			}
			else
			{
			writer.write("POINT"+"\t"+points.get(a).getName() + "\t" + points.get(a).getXcord() + "\t"
					+ points.get(a).getYcord()+"\t!dest"+"\t"+points.get(a).getLoc());
			writer.write("\n");
			}
		}
		writer.write("EDGES\n");
		for(int b=0; b<edges.size(); b++)
		{
		writer.write("EDGE"+"\t"+b+"\t"+ edges.get(b).returnFrom().getLoc()+ "\t"
				+edges.get(b).returnTo().getLoc()+"\t"+edges.get(b).getCost());	
		writer.write("\n");
		}
		writer.write("END");
		writer.close();
	} catch (IOException e) {
		e.printStackTrace();
	}
	}
	 public void load()
	{
		 clearAll();
		BufferedReader r = null;
		try {
			r = new BufferedReader(new FileReader(SAVEFILE));
		}
		catch(FileNotFoundException e)
		{
			e.printStackTrace();
		}
		try{
			while(true)
			{
			String line = r.readLine();
			String[] words = line.split("\t");
			if(line.equals("END")){
				break;
			}
			if(words[0].equals("POINT"))
			{
				if(words[4].equals("dest"))
				{
					points.add(new Node(words[1], Integer.parseInt(words[2]), Integer.parseInt(words[3]), true, Integer.parseInt(words[5])));
					wayIndex++;
					listIndex++;
				}
				else
				{
					points.add(new Node(words[1], Integer.parseInt(words[2]), Integer.parseInt(words[3]), false, Integer.parseInt(words[5])));
					wayIndex++;
					listIndex++;
				}
			}
			if(words[0].equals("EDGE"))
			{
				Edge tempEdge = new Edge(points.get(Integer.parseInt(words[2])), points.get(Integer.parseInt(words[3])), Double.parseDouble(words[3]));
				edges.add(tempEdge);
				points.get(Integer.parseInt(words[2])).addEdge(tempEdge);
			}
	
			}
		}
		catch(IOException e)
		{
		e.printStackTrace();
		}
			
		this.drawObjects();
	}
	@Override
	public void run() {
		this.drawObjects();
	}
	@Override
	public void mousePressed(MouseEvent e)
	{
		for(int k=0; k<points.size(); k++)
		{
			if((e.getX()>points.get(k).getXcord())&&(e.getX()<points.get(k).getXcord()+10))//checks x cords
			{
				//System.out.println("x start reached");
				if((e.getY()>points.get(k).getYcord())&&(e.getY()<points.get(k).getYcord()+10))
				{
				 //System.out.println("y start reached");
				 //System.out.println("NODE MATCH");
				 startNode = points.get(k);
				 addingEdge = true;
				}
			}
			
		}
		this.drawObjects();
		
	}
	@Override
	public void mouseDragged(MouseEvent e)
	{
		Node tempNode = new Node("", e.getX(), e.getY(), false, 0);
		if(edit&&addingEdge)
		{
			edges.add(0,new Edge(startNode, tempNode));
			 this.drawObjects();
			 edges.remove(0);
		}
	}
	@Override
	public void mouseReleased(MouseEvent e)//checks y cords
	{
		String costOverride= costBox.getText();
		if(edit&&addingEdge)
		{
			for(int k=0; k<points.size(); k++)
			{
				if((e.getX()>points.get(k).getXcord()-10)&&(e.getX()<points.get(k).getXcord()+10))
				{
					//System.out.print("X Cord match!");
					if((e.getY()>points.get(k).getYcord()-10)&&(e.getY()<points.get(k).getYcord()+10))
					{
				   // System.out.println("Y Cord match!");
						endNode = points.get(k);
						if(startNode.equals(endNode))
						{
							System.out.println("You can't add a point to itself");
						}
						else 
						{
							if(costOverride.equals(COSTTEXT))
							{
								edges.add(new Edge(startNode, endNode));
								startNode.addEdge(new Edge(startNode, endNode));
								endNode.addEdge(new Edge(endNode, startNode));
							}
							else
							{
								double tempcost = Double.parseDouble(costBox.getText());
								edges.add(new Edge(startNode, endNode,tempcost));
								startNode.addEdge(new Edge(startNode, endNode,tempcost));
								endNode.addEdge(new Edge(endNode, startNode, tempcost));
							}
						}
					}
				}
				
			}
		}
		this.drawObjects();
	}
	@Override
	public void mouseClicked(MouseEvent e) {
		
		if(edit)
		{
			if(way)
			{
				wayIndex++;
				points.add(new Node("Waypoint:"+wayIndex,e.getX(), e.getY(), false, listIndex));
				listIndex++;
				}
			if(dest)
			{
				points.add(new Node(destBox.getText(),e.getX(), e.getY(), true, listIndex));
				listIndex++;
				//System.out.println(points);
				
			}
		}
		this.drawObjects();
	}
	public void convertPath(String s1, String s2)
	{
		for(int i =0; i<points.size(); i++)
		{
			if(points.get(i).getName().equals(s1))
			{
				startN = points.get(i);
			}
			 if(points.get(i).getName().equals(s2))
			 {
				 endN = points.get(i);
			 }
		}
	}
	public void drawObjects()
	{
    	int wayCounter = 0;
		
		this.getFrame().clearGraphics();
		this.getFrame().drawImage(0, 0, mapFile);
        for(int k=0; k<texts.size(); k++)
        {
    		this.getFrame().setForegroundColor(Color.red);
        	this.getFrame().addObject(texts.get(k));
        }
        for(int c=0; c<points.size(); c++)
		{
        	SGText tempText;
        	this.getFrame().setForegroundColor(points.get(c).returnColor());
			this.getFrame().addObject(points.get(c).getShape());
			this.getFrame().setForegroundColor(Color.black);
			if(points.get(c).destination)
			{
				tempText = new SGText(points.get(c).getName(), points.get(c).getXcord(), points.get(c).getYcord()+20);
			}
			else
			{
				wayCounter++;
				tempText = new SGText(""+wayCounter, points.get(c).getXcord(), points.get(c).getYcord()+20);
			}
				
				this.getFrame().addObject(tempText);
		}
        for(int i=0; i<edges.size(); i++)
        {
        	int midPx = (int)edges.get(i).calcMidpointX();
        	int midPy = (int)edges.get(i).calcMidpointY();
        		this.getFrame().setForegroundColor(Color.black);
        		this.getFrame().addObject(edges.get(i).getShape());
        		this.getFrame().addObject(new SGText(""+edges.get(i).getCost(), midPx, midPy));
        		
        }
	}


	public ArrayList<Node> mySearch(Node a, Node b)
	{
		List<Node> explored = new ArrayList<Node>();
		ArrayList<Node> path = new ArrayList<Node>();
		boolean foundPath = false;
		Node current = a;
		while(!foundPath)
		{
			explored.add(current);
			List<Edge> children = current.getEdges();
			if(current.equals(b))
				{
					while(!foundPath)
						{
							path.add(0, current);
								if(current.equals(a))
										return path;
			 
							current = current.getPrevious();
						}
				}
			deleteDupes(explored, children);
			if(children.size()==0)
			{
			System.out.println("No valid children: continuing after point " + current.getName());
			current = current.getLast();
			children = current.getEdges();
			deleteDupes(explored, children);
			}
			Node temp = findSmallestChild((ArrayList<Edge>)children);
			temp.setLast(current);
			System.out.println(temp.getName());
			current = temp;
			
			
		}
		System.out.println("search fail");
		return path;
	}
		
	public void clearAll()
	{
		texts.clear();
		points.clear();
		edges.clear();
		edit = false;
		way= false;
		dest= false;
		addingEdge= false;
		searchMode = false;
		wayIndex = 0;
		listIndex =0;
		this.getFrame().clearGraphics();
		this.drawObjects();
	}
	public void setPath(int[] arr, ArrayList<Edge> edgs)
	{
		for(int i : arr)
		{
			edgs.get(i).setPath(true);
		}
		this.drawObjects();
	}
	
	public void deleteDupes(List<Node> original, List<Edge> deleter)
	{
	 for(int u = 0; u<original.size(); u++)
	 {
		 Node currentCheck = original.get(u);
		 for(int i = 0; i<deleter.size(); i++)
		 {
			 if(currentCheck.equals(deleter.get(i).returnTo()))
				 deleter.remove(i);
			 
		 }
	 }
		 
	}
	public List<Node> findChildren(Node n)
	{
		List<Node> resultList = new ArrayList<Node>();
		List<Edge> edges = n.getEdges();
		for(int k=0; k<edges.size(); k++)
		{
			//resultList.add(edges.get(k));
		}
		return resultList;
	}
	
	public Node findSmallestChild(ArrayList<Edge> edges)
	{
	double small = Double.MAX_VALUE;
	Node track = null;
		for(int a=0; a<edges.size(); a++)
		{
			if(edges.get(a).getCost()<small)
			{
				small = edges.get(a).getCost();
				track = edges.get(a).returnTo();
			}
		}
	return track;	
	}
	public Edge getSmallEdge(List<Edge> edges)
	{
			Edge e = null;
	
			double small = Double.MAX_VALUE;
				for(int a=0; a<edges.size(); a++)
				{
					if(edges.get(a).getCost()<small)
					{
						small = edges.get(a).getCost();
						e = edges.get(a);
					}
				}	
				return e;
	}
	
	public boolean inList(List<Node> nodes, Node n)
	{
		for(int a=0; a<nodes.size(); a++)
		{
			if(nodes.get(a).equals(n))
				return true;
		}
		return false;
	}
	public void highlightPath(ArrayList<Node> nodes)
	{
		this.getFrame().setForegroundColor(Color.cyan);
		for(int i =0; i<nodes.size()-1; i++)
		{
			for(int k=0; k<5; k++)
			{
				this.getFrame().drawLine(nodes.get(i).getXcord(), nodes.get(i).getYcord(), nodes.get(i+1).getXcord(), nodes.get(i+1).getYcord());
			}
		}
	}
	
	
	
	
	
}

